/************************************************************************/
/* main.ct@C                                                       */
/* CvO                                                     */
/************************************************************************/
#include "includes.h"

#define  VOICE_FILENAME       "VOICE.WAV"                               /* ^/Đt@C */

USB_INT32U dwWaveDataSize=0;                                            /* WAVEf[^TCY */


/*----------------------------------------------------------------------*/
/* @\F7ZOfobOo                                              */
/* Fo͒l                                                         */
/* ߂lFȂ                                                         */
/*----------------------------------------------------------------------*/
void debug_out(USB_INT08U val)
{
    CQBBEL_LED_out(val);
}


/*----------------------------------------------------------------------*/
/* @\Ft@C4oCgf[^擾                                  */
/* Ft@C|C^                                               */
/* ߂lF4oCgf[^                                                */
/*----------------------------------------------------------------------*/
USB_INT32U
get_ulong(
    USB_INT32S    fp
)
{
    USB_INT08U s[4];
    USB_INT32U value;
    
    if(!FILE_Read(fp, s, 4)){
        return 0;
    }
    value  = s[0];
    value += ((USB_INT32U)s[1])<<8;
    value += ((USB_INT32U)s[2])<<16;
    value += ((USB_INT32U)s[3])<<24;
    
    return value;
}


/*----------------------------------------------------------------------*/
/* @\Ft@C2oCgf[^擾                                  */
/* Ft@C|C^                                               */
/* ߂lF2oCgf[^                                                */
/*----------------------------------------------------------------------*/
USB_INT16U
get_ushort(
    USB_INT32S fp
)
{
    USB_INT08U s[2];
    USB_INT16U value;
    
    if(!FILE_Read(fp, s, 2)){
        return 0;
    }
    
    value  = s[0];
    value += ((USB_INT16U)s[1])<<8;
    
    return value;
}


/*----------------------------------------------------------------------*/
/* @\F`Nf[^擾                                             */
/* Ffp       t@C|C^                                      */
/*       chunk    `Nf[^i[̈                                */
/* ߂lF`Nf[^TCY                                         */
/*----------------------------------------------------------------------*/
USB_INT32U
chunkRead(
    USB_INT32S fp,
    USB_INT08U *chunk
)
{
    if(!FILE_Read(fp, chunk, 4)){
        return 0;
    }
    return get_ulong(fp);
}


/*----------------------------------------------------------------------*/
/* @\Ft@C4oCgf[^                                */
/* Ffp       t@C|C^                                      */
/*       value    ސl                                          */
/* ߂lF0:I1:ُI                                         */
/*----------------------------------------------------------------------*/
USB_INT08U
set_ulong(
    USB_INT32S fp,
    USB_INT32U value
)
{
    USB_INT08U s[4];
    
    s[0] = (USB_INT08U)(value);
    s[1] = (USB_INT08U)(value>>8);
    s[2] = (USB_INT08U)(value>>16);
    s[3] = (USB_INT08U)(value>>24);
    
    if(!FILE_Write(fp, s, 4)){
        return 1;
    }
    return 0;
}


/*----------------------------------------------------------------------*/
/* @\Ft@C2oCgf[^                                */
/* Ffp       t@C|C^                                      */
/*       value    ސl                                          */
/* ߂lF0:I1:ُI                                         */
/*----------------------------------------------------------------------*/
USB_INT08U
set_ushort(
    USB_INT32S fp,
    USB_INT16U value
)
{
    USB_INT08U s[2];
    
    s[0] = (USB_INT08U)(value);
    s[1] = (USB_INT08U)(value>>8);
    
    if(!FILE_Write(fp, s, 2)){
        return 1;
    }
    return 0;
}


/*----------------------------------------------------------------------*/
/* @\Ft@Cփ`Nf[^                               */
/* Ffp       t@C|C^                                      */
/*       chunk    `Nf[^i[̈                                */
/* ߂lF0:I1:ُI                                         */
/*----------------------------------------------------------------------*/
USB_INT08U
chunkWrite(
    USB_INT32S fp,
    USB_INT08U *chunk
)
{
    if(!FILE_Write(fp, chunk, 4)){
        return 1;
    }
    return 0;
}


/*----------------------------------------------------------------------*/
/* @\Ft@CWAVEf[^wb_[                         */
/* Ffp       t@C|C^                                      */
/* ߂lF0:IiŒj                                           */
/*----------------------------------------------------------------------*/
int
make_WAV_File(
    USB_INT32S fp
)
{
    chunkWrite(fp, "RIFF");                                             /* wb_[ "RIFF" */
    set_ulong(fp, (24+8+dwWaveDataSize));                               /* ȍ~̃t@CTCYiŜ̃t@CTCY-8j */
    chunkWrite(fp, "WAVE");                                             /* wb_[ "WAVE" */
    chunkWrite(fp, "fmt ");                                             /* `N "fmt " */
    set_ulong (fp, 16);                                                 /* `N "fmt "̃TCY */
    set_ushort(fp, ADC_FORMATTAG);                                      /* tH[}bg` */
    set_ushort(fp, ADC_CHANNELS);                                       /* `l (mono:1 stereo:2) */
    set_ulong (fp, ADC_SAMPLESPERSEC);                                  /* TvO[g (Hz) */
    set_ulong (fp, ADC_AVGBYTESPERSEC);                                 /* f[^x (Byte/sec) */
    set_ushort(fp, ADC_BLOCKALIGN);                                     /* ubNTCY ((Byte/sample * CH) */
    set_ushort(fp, ADC_BITSPERSAMPLE);                                  /* Tṽrbg (8bit or 16bit) */
    chunkWrite(fp, "data");                                             /* `N "data" */
    set_ulong(fp, dwWaveDataSize);                                      /* `N "data"̃TCY */
    
    return 0;
}


/*----------------------------------------------------------------------*/
/* @\F ADCC                                                 */
/* FȂ                                                           */
/* ߂lFȂ                                                         */
/*----------------------------------------------------------------------*/
void
ADC_Main(void)
{
    USB_INT32S fp=NULL;
    USB_INT32U write_bytes;
    USB_INT32U total_bytes;

    dwWaveDataSize=0;

/************************************/
/* Ŋ̃t@C폜 */
/************************************/
    FILE_Delete(VOICE_FILENAME);

/**********************/
/* t@C̐VK쐬 */
/**********************/
    fp = FILE_Open(VOICE_FILENAME, RDWR);
    if(fp){
/*******************************/
/* WAVt@C̃wb_[쐬 */
/*******************************/
        dwWaveDataSize = (ADC_DEFAULT_FILESIZE/2);
        if(make_WAV_File(fp)){
            FILE_Close(fp);
            return;
        }

/***********/
/* ADCݒ */
/***********/
        fBufFull_Bank0=0;
        fBufFull_Bank1=0;
        ADC_MicData = (USB_INT08U *)UserBuffer;
        ADC_Config();
    }else{
        return;
    }

/**********************************************************************************************************/
/* {[vADCŎMf[^ݑB̊ԁA^C}荞݂ɂADC特MA */
/* obt@̊eBANKFULLɂȂt@Cɏ݁Ãobt@BANKtONAB             */
/**********************************************************************************************************/
    total_bytes=0;
    ADC_RecvEnable();                                                   /* ADCMJn */

    for(;;){
        if(total_bytes <= dwWaveDataSize){                              /* Kf[^TCYȓH */
            if(fBufFull_Bank0){                                         /* BANK0FULLɂȂH */
                write_bytes = FILE_Write(fp, ADC_MicData, ADC_BANK_SIZE);
                                                                        /* BANK0̃f[^ */
                if(write_bytes){
                    fBufFull_Bank0=0;                                   /* BANK1FULLtONA */
                    total_bytes += write_bytes;                         /* g[^TCYXV */
                }
            }else if(fBufFull_Bank1){                                   /* BANK0FULLɂȂH */
                write_bytes = FILE_Write(fp, ADC_MicData+ADC_BANK_SIZE, ADC_BANK_SIZE);
                                                                        /* BANK1̃f[^ */
                if(write_bytes){
                    fBufFull_Bank1=0;                                   /* BANK1FULLtONA */
                    total_bytes += write_bytes;                         /* g[^TCYXV */
                }
            }
        }else{
            break;                                                      /* KTCY܂ŏ݂II */
        }
        
        if(PushSW_GetSW()&0x08){                                        /* f삳ꂽ狭I */
            break;                                                      /* fꍇA쐬f[^WindowsŐ */
        }                                                               /* ĐłȂ\ */
    }
    ADC_RecvDisable();                                                  /* ADCMI */
    FILE_Close(fp);                                                     /* t@C */
}


/*----------------------------------------------------------------------*/
/* @\Ft@CWAVEf[^wb_[ǂݍŉ͂             */
/* Ffp       t@C|C^                                      */
/* ߂lF0:IA1:ُI                                       */
/*----------------------------------------------------------------------*/
int
scan_WAV_File(
    USB_INT32S fp
)
{
    USB_INT32U size;
    USB_INT08U chunk[5];
    USB_INT08U temp[32];

    if((size = chunkRead(fp, chunk)) <= 0){                              /* wb_[ "RIFF"`FbN */
        return 1;
    }
    if (strncmp((char const *)chunk, "RIFF", 4) != 0) {
        return 1;
    }

    if(!FILE_Read(fp, chunk, 4)){                                        /* wb_[ "WAVE"`FbN */
        return 1;
    }
    if(strncmp((char const *)chunk, "WAVE", 4) != 0){
        return 1;
    }

    if((size = chunkRead(fp, chunk)) <= 0){                             /* `N "fmt "`FbN */
        return 1;
    }
    if(strncmp((char const *)chunk, "fmt ", 4) != 0){
        return 1;
    }
    wFormatTag       = get_ushort(fp);                                  /* tH[}bg` */
    wChannels        = get_ushort(fp);                                  /* `l (mono:1 stereo:2) */
    dwSamplesPerSec  = get_ulong(fp);                                   /* TvO[g (Hz) */
    dwAvgBytesPerSec = get_ulong(fp);                                   /* f[^x (Byte/sec) */
    wBlockAlign      = get_ushort(fp);                                  /* ubNTCY ((Byte/sample * CH) */
    wBitsPerSample   = get_ushort(fp);                                  /* Tṽrbg (8bit or 16bit) */

    if(size>16){                                                        /* g񂪑݂ǂ݂ */
        FILE_Read(fp, temp, (size-16));
    }

    if((size = chunkRead(fp, chunk)) <= 0){                             /* `N "data" */
        return 1;
    }
    if(strncmp((char const *)chunk, "data", 4) != 0){
        return 1;
    }
    dwWaveDataSize = size;                                              /* f[^TCYۑ */
    
    return 0;
}


/*----------------------------------------------------------------------*/
/* @\F DACC                                                 */
/* FȂ                                                           */
/* ߂lFȂ                                                         */
/*----------------------------------------------------------------------*/
void
DAC_Main(void)
{
    USB_INT32S fp;
    USB_INT32U read_bytes;

/******************************/
/* t@CI[v */
/******************************/
    fp = FILE_Open(VOICE_FILENAME, RDONLY);

    if(fp > 0){
/*************************/
/* WAVt@C̓e */
/*************************/
        if(scan_WAV_File(fp)){
            FILE_Close(fp);
            return;
        }

/***********/
/* DACݒ */
/***********/
        fBufEmpty_Bank0=0;
        fBufEmpty_Bank1=0;
        DAC_SpkData = (USB_INT08U *)UserBuffer;
        DAC_Config();
    }else{
        return;
    }

/***********************************************************************************************************/
/* {[vŐ擪I[܂ŋȃt@CǂݑB̊ԁA^C}[荞݂ɂ艹yDACɑB */
/* DAC֑Iobt@BANKtONAABANK֑̃f[^ǂݍށB                 */
/***********************************************************************************************************/
    read_bytes = FILE_Read(fp, DAC_SpkData, (DAC_BANK_SIZE*2));         /* ܂͍ŏ̃f[^_uobt@֓ǂł */

    DAC_SendEnable();                                                   /* DAC֑MJn */

    for(;;){
        if(fBufEmpty_Bank0){                                            /* BANK0ɂȂH */
            read_bytes = FILE_Read(fp, DAC_SpkData, DAC_BANK_SIZE);     /* BANK0Ƀf[^ǂݍ */
            if(read_bytes){
                fBufEmpty_Bank0=0;                                      /* BANK0EMPTYtONA */
            }
        }else if(fBufEmpty_Bank1){                                      /* BANK0ɂȂH */
            read_bytes = FILE_Read(fp, DAC_SpkData+DAC_BANK_SIZE, DAC_BANK_SIZE);   
                                                                        /* BANK0Ƀf[^ǂݍ */
            if(read_bytes){
                fBufEmpty_Bank1=0;                                      /* BANK0EMPTYtONA */
            }
        }

        if(read_bytes < DAC_BANK_SIZE){                                 /* t@C̏I[܂œǂݏI */
            if(fBufEmpty_Bank0 && fBufEmpty_Bank1){                     /* SBANK̃f[^ɂȂI */
                break;
            }
        }

        if(PushSW_GetSW()&0x08){                                        /* f삳ꂽ狭I */
            break;
        }
    }
    DAC_SendDisable();                                                  /* DAC֑MI */
    FILE_Close(fp);                                                     /* t@C */
}


/*----------------------------------------------------------------------*/
/* @\F C                                                    */
/* FȂ                                                           */
/* ߂lFȂ                                                         */
/*----------------------------------------------------------------------*/
int
main(void)
{
    USB_INT32S rc = ERR_TD_FAIL;

    USB_INT08S button=0;

    CPU_Initialize();                                                   /* CPU */

    CQBBEL_init();                                                      /* CQ-BBEL{[h֘A */

    Host_Init();                                                        /* USBzXgRg[ */

    CPU_EnableInterrupt();                                              /* 荞݋ */

/****************/
/* C[v */
/****************/
    for(;;){
        debug_out(90);
        rc = Host_EnumDev();                                            /* USBfoCX̃Gj[V */
        if(rc != OK){
            continue;;
        }
        debug_out(91);
        rc = MS_Init();                                                 /* MassStorageClass */
        if(rc != OK){
            continue;;
        }
        debug_out(92);
        rc = FAT_Init();                                                /* FATt@CVXe */
        if(rc != OK){
            continue;;
        }
        for(;;){
            if(!GetPlugStatus()){                                       /* vOXe[^X̃`FbN */
                break;                                                  /* vOAEgꂽ珈[v𔲂 */
            }
            debug_out(0);
            button = PushSW_GetSW();                                    /* {^擾 */

/***********/
/* ADCf */
/***********/
            if((button&0x01)){
                debug_out(1);
                ADC_Init();                                             /* ADC */
                ADC_Main();                                             /* ADCC */

/***********/
/* DACf */
/***********/
            }else if(button&0x02){
                debug_out(11);
                dwWaveDataSize=0;
                DAC_Init();                                             /* DAC */
                DAC_Main();                                             /* DACC */

/*****************/
/* ADC & DACf */
/*****************/
            }else if((button&0x04)){
                debug_out(21);
                ADC_Init();                                             /* ADC */
                ADC_Main();                                             /* ADCC */
                debug_out(22);
                DAC_Init();                                             /* DAC */
                DAC_Main();                                             /* DACC */
            }
        }
    }
}
