/************************************************************************/
/* hardware.ct@C                                                   */
/* CPU(LPC2388) e평[`                                      */
/************************************************************************/
#include "includes.h"

#define I_RC_OSC_FREQ     (4*1000000l)                                  /* 4MHz */
#define MAIN_OSC_FREQ     (12*1000000l)                                 /* 12MHz */
#define RTC_OSC_FREQ      (32768UL)

/*----------------------------------------------------------------------*/
/* @\FFIQ荞݃nh                                            */
/* FȂ                                                           */
/* ߂lFȂ                                                         */
/*----------------------------------------------------------------------*/
#ifdef IAR_BUILD
__fiq __arm void FIQ_Handler (void)
#else /* IAR_BUILD */
void FIQ_Handler(void) __attribute__ ((interrupt("FIQ")));
void FIQ_Handler (void)
#endif /* IAR_BUILD */
{
/*******************************/
/* ADC荞݃nhĂяo */
/*******************************/
    if(fADC_Enable){
        ADC_Handler();
    }

/*******************************/
/* DAC荞݃nhĂяo */
/*******************************/
    if(fDAC_Enable){
        DAC_Handler();
    }

    T0IR = T0IR;
}


/*----------------------------------------------------------------------*/
/* @\FIRQ荞݃nh                                            */
/* FȂ                                                           */
/* ߂lFȂ                                                         */
/*----------------------------------------------------------------------*/
#ifdef IAR_BUILD
__irq __arm void IRQ_Handler (void)
#else /* IAR_BUILD */
void IRQ_Handler(void) __attribute__ ((interrupt("IRQ")));
void IRQ_Handler (void)
#endif /* IAR_BUILD */
{
    void (*interrupt_function)();
    unsigned int vector;

/*****************************************/
/* 荞݃xN^擾APIĂяo */
/*****************************************/
    vector = VICVectAddr;                                               /* 荞݃xN^擾 */
    interrupt_function = (void(*)())vector;
    if(interrupt_function != NULL){
      interrupt_function();                                             /* 荞݊֐Ăяo */
    }else{
        VICVectAddr = 0;                                                /* 荞݃xN^̃NA */
    }
}


/*----------------------------------------------------------------------*/
/* @\FVIC̏                                                    */
/* FȂ                                                           */
/* ߂lFȂ                                                         */
/*----------------------------------------------------------------------*/
void VIC_Init(void)
{
    volatile unsigned long * pVecAdd, *pVecCntl;
    int i;

/***************************/
/* VIC֘AWX^̏ */
/***************************/
    VICIntSelect  = 0;                                                  /* SIRQ`l̏ */
    VICIntEnClr   = 0xFFFFFFFF;                                         /* S荞݂̖ */
    VICSoftIntClr = 0xFFFFFFFF;                                         /* \tgEFA荞݂̃NA */
    VICProtection = 0;                                                  /* VICWX^̓[U[hA[ĥ */
    VICVectAddr   = 0;                                                  /* 荞݃xN^̃NA */

/*****************************************/
/* 荞݃[`IRQXbg̏ */
/*****************************************/
    for(i = 0,    pVecCntl = &VICVectCntl0, pVecAdd = &VICVectAddr0; i < 32; ++i){
        *pVecCntl++ = *pVecAdd++ = 0;
    }
}


/*----------------------------------------------------------------------*/
/* @\FNbN̏                                               */
/* FȂ                                                           */
/* ߂lFȂ                                                         */
/*----------------------------------------------------------------------*/
void InitClock(void)
{
/***************/
/* OSC̏ */
/***************/
    SCS &= ~SCS_OSCRANGE;                                               /* SCS OSCRANGE = 0 */
    SCS |= SCS_OSCEN;                                                   /* SCS OSCEN = 1; */
    while(!(SCS & SCS_OSCSTAT));                                        /* OSC ready҂ */

/***************/
/* PLLS~ */
/***************/
    PLLCON &= ~PLLC;                                                    /* PLLCON PLLC = 0 */
    PLLFEED = 0xAA;
    PLLFEED = 0x55;
    PLLCON &= ~PLLE;                                                    /* PLLCON PLLE = 0 */
    PLLFEED = 0xAA;
    PLLFEED = 0x55;

/*******************************************/
/* PLLNbN\[XƂăCUI */
/*******************************************/
    CLKSRCSEL |= CLKSRC_MAIN_OSC;                                       /* CLKSRCSEL CLKSRC = 1 */

/********************************/
/* PLL 288 MHzAMSEL 23ANSEL 1 */
/********************************/
    PLLCFG = (MSEL_MASK & (24-1));                                      /* PLLCFG MSEL = 24-1 */
    PLLCFG |= (NSEL_MASK & ((2-1)<<16));                                /* PLLCFG NSEL = 2-1 */
    PLLFEED = 0xAA;
    PLLFEED = 0x55;

/***********/
/* PLLL */
/***********/
    PLLCON |= PLLE;                                                     /* PLLCON PLLE = 1 */
    PLLFEED = 0xAA;
    PLLFEED = 0x55;
    while(!(PLLSTAT & PLOCK));                                          /* PLL LOCKrbg҂ */
    
/*******************/
/* CPUNbNݒ */
/*******************/
    CCLKCFG   = 4-1;                                                    /* 1/4 Fpll - 72 MHz */
    USBCLKCFG = 6-1;                                                    /* 1/6 Fpll - 48 MHz */
    PCLKSEL0  = PCLKSEL1 = 0;                                           /* ̑ - 18MHz (Fcclk/4) */
    // 10. Connect the PLL
    PLLCON |= PLLC;                                                     /* PLLCON PLLC = 1 */
    PLLFEED = 0xAA;
    PLLFEED = 0x55;

/******************************/
/* ׂĂ̎ӂ̃NbN~ */
/******************************/
    PCONP = 0;
}


/*----------------------------------------------------------------------*/
/* @\FVXeNbN̎擾                                         */
/* FȂ                                                           */
/* ߂lFSclk [Hz]                                                    */
/*----------------------------------------------------------------------*/
USB_INT32U SYS_GetFsclk(void)
{
    USB_INT32U Mul = 1, Div = 1, Osc, Fsclk;

    if(PLLCON & PLLC){
        Mul = (PLLCFG & MSEL_MASK) + 1;                                    /* Mul = PLLSTAT MSEL + 1 */
        Div = ((PLLCFG & NSEL_MASK) >> 16) + 1;                           /* Div = PLLSTAT NSEL + 1 */
    }

    switch(CLKSRCSEL & CLKSRC_MASK){
    case CLKSRC_RC_OSC:
        Osc = I_RC_OSC_FREQ;
        break;
    case CLKSRC_MAIN_OSC:
        Osc = MAIN_OSC_FREQ;
        break;
    case CLKSRC_RTC_OSC:
        Osc = RTC_OSC_FREQ;
        break;
    default:
        Osc = 0;
    }

    Fsclk = Osc*Mul*2;
    Fsclk /= Div*(CCLKCFG+1);
    return(Fsclk);
}


/*----------------------------------------------------------------------*/
/* @\FӃNbN̎擾                                             */
/* FȂ                                                           */
/* ߂lFPclk [Hz]                                                    */
/*----------------------------------------------------------------------*/
USB_INT32U SYS_GetFpclk(USB_INT32U Periphery)
{
    USB_INT32U Fpclk;
    USB_INT32U *pReg = (USB_INT32U *)((Periphery < 32)?&PCLKSEL0:&PCLKSEL1);

    Periphery    &= 0x1F;
    Fpclk = SYS_GetFsclk();

    switch((*pReg >> Periphery) & PCLKSEL_TIMER_MASK){
    case PCLKSEL_DIV_4:
        Fpclk /= 4;
        break;
    case PCLKSEL_DIV_1:
        break;
    case PCLKSEL_DIV_2:
        Fpclk /= 2;
        break;
    case PCLKSEL_DIV_8:
    default:
        Fpclk /= 8;
    }
    return(Fpclk);
}


/*----------------------------------------------------------------------*/
/* @\FGPIȌ                                                   */
/* FȂ                                                           */
/* ߂lFȂ                                                         */
/*----------------------------------------------------------------------*/
void GpioInit(void)
{
/************************************/
/* fBNVRg[ */
/************************************/
    IODIR0 = 0;
    IODIR1 = 0;
    FIO0DIR = 0;
    FIO1DIR = 0;
    FIO2DIR = 0;
    FIO3DIR = 0;
    FIO4DIR = 0;

/****************/
/* GPIOL */
/****************/
    SCS |= SCS_GPIO_HIGH_SPEED;                                         /* SCS GPIOM = 1 */

/************************/
/* }XNWX^NA */
/************************/
    FIO0MASK = 0;
    FIO1MASK = 0;
    FIO2MASK = 0;
    FIO3MASK = 0;
    FIO4MASK = 0;

/************************/
/* SGPIOs̃Zbg */
/************************/
    PINSEL0 = 0;
    PINSEL1 = 0;
    PINSEL2 = 0;
    PINSEL3 = 0;
    PINSEL4 = 0;
    PINSEL5 = 0;
    PINSEL6 = 0;
    PINSEL7 = 0;
    PINSEL8 = 0;
    PINSEL9 = 0;
    PINSEL10= 0;
}


/*----------------------------------------------------------------------*/
/* @\FCPȔ                                                    */
/* FȂ                                                           */
/* ߂lFȂ                                                         */
/*----------------------------------------------------------------------*/
void CPU_Initialize(void)
{
    MAMCR  = 0x00;                                                      /* MAM̏ */
    MAMTIM = 0x03;                                                      /* FCLK > 40 MHz */
    MAMCR  = 0x02;                                                      /* MAML */

    InitClock();                                                        /* NbN̏ */
    GpioInit();                                                         /* GPIȌ */
    VIC_Init();                                                         /* VIC̏ */
}


/*----------------------------------------------------------------------*/
/* @\FCPU荞݋                                                */
/* FȂ                                                           */
/* ߂lFȂ                                                         */
/*----------------------------------------------------------------------*/
void CPU_EnableInterrupt(void)
{
#ifdef IAR_BUILD
    __enable_interrupt();
#else /* IAR_BUILD */
    volatile unsigned int CPSR_val;
    asm ("MRS %0, CPSR": "=r" (CPSR_val):);
    
    CPSR_val &= ~0xC0;
    asm ("MSR CPSR, %0": :"r" (CPSR_val));
#endif /* IAR_BUILD */
}


/*----------------------------------------------------------------------*/
/* @\FCPU荞݋֎~                                                */
/* FȂ                                                           */
/* ߂lFȂ                                                         */
/*----------------------------------------------------------------------*/
void CPU_DisableInterrupt(void)
{
#ifdef IAR_BUILD
    __disable_interrupt();
#else /* IAR_BUILD */
    volatile unsigned int CPSR_val;
    asm ("MRS %0, CPSR": "=r" (CPSR_val):);
    CPSR_val |= 0xC0;
    asm ("MSR CPSR, %0": :"r" (CPSR_val));
#endif /* IAR_BUILD */
}
